﻿##https://activedirectoryfaq.com/2017/08/creating-individual-random-passwords/
##↑のサンプルコードを利用して編集した。

using namespace System.Windows.Forms
Add-Type -AssemblyName System.Windows.Forms
Add-Type -AssemblyName System.Drawing

# ビジュアルスタイルを適用（未記載の場合クラシック形式の表示）
[Application]::EnableVisualStyles()

# ラベル
$Label_01 = New-Object System.Windows.Forms.Label
$Label_01.Text = "【パスワード生成　簡易プログラム By @word】"
$Label_01.Location = "170, 10"
$Label_01.AutoSize = $True
$Label_02 = New-Object System.Windows.Forms.Label
$Label_02.Text = "①　パスワードに使用する文字と記号の桁数を選択してください！"
$Label_02.Location = "29, 40"
$Label_02.AutoSize = $True
$Label_03 = New-Object System.Windows.Forms.Label
$Label_03.Text = "アルファベット（小文字）　："
$Label_03.Location = "29, 73"
$Label_03.AutoSize = $True
$Label_04 = New-Object System.Windows.Forms.Label
$Label_04.Text = "アルファベット（大文字）　："
$Label_04.Location = "29, 103"
$Label_04.AutoSize = $True
$Label_05 = New-Object System.Windows.Forms.Label
$Label_05.Text = "英数字　："
$Label_05.Location = "103, 133"
$Label_05.AutoSize = $True
$Label_06 = New-Object System.Windows.Forms.Label
$Label_06.Text = "記号　："
$Label_06.Location = "115, 163"
$Label_06.AutoSize = $True
$Label_07 = New-Object System.Windows.Forms.Label
$Label_07.Text = "②　パスワードを生成する"
$Label_07.Location = "29, 190"
$Label_07.AutoSize = $True
$Label_08 = New-Object Textbox
$Label_08.Text = ""
$Label_08.Location = "29, 220"
$Label_08.Size ="200,20"
$Label_09 = New-Object System.Windows.Forms.Label
$Label_09.Text = "※コピー＆ペーストしてご利用ください！"
$Label_09.Location = "29, 250"
$Label_09.AutoSize = $True
$Label_10 = New-Object System.Windows.Forms.Label
$Label_10.Text = "『abcdefghikmnoprstuvwxyz』　※小文字の　Ｌ　を除外"
$Label_10.Location = "240, 73"
$Label_10.AutoSize = $True
$Label_11 = New-Object System.Windows.Forms.Label
$Label_11.Text = "『ABCDEFGHKLMNOPRSTUVWXYZ』　※大文字の　i　を除外"
$Label_11.Location = "240, 103"
$Label_11.AutoSize = $True
$Label_12 = New-Object System.Windows.Forms.Label
$Label_12.Text = "『234567890』　※英数字の　壱　を除外"
$Label_12.Location = "240, 133"
$Label_12.AutoSize = $True
$Label_13 = New-Object System.Windows.Forms.Label
$Label_13.Text = "『!$%&/()=?}][{@#』"
$Label_13.Location = "240, 163"
$Label_13.AutoSize = $True

#入力欄:アルファベット（小文字）
$Small_ALFA = New-Object combobox
$Small_ALFA.Name = "Small_ALFA"
$Small_ALFA.DropDownStyle = "DropDown"
$Small_ALFA.FlatStyle = "standard"
$Small_ALFA.Location = "170, 70"
$Small_ALFA.Size ="50,20"
$Small_ALFA.text ="2"
##コンボボックスに項目を追加
[void] $Small_ALFA.Items.Add("1")
[void] $Small_ALFA.Items.Add("2")
[void] $Small_ALFA.Items.Add("3")
[void] $Small_ALFA.Items.Add("4")
[void] $Small_ALFA.Items.Add("5")
[void] $Small_ALFA.Items.Add("6")
#入力欄:アルファベット（大文字）
$Big_ALFA = New-Object combobox
$Big_ALFA.Name = "Big_ALFA"
$Big_ALFA.DropDownStyle = "DropDown"
$Big_ALFA.FlatStyle = "standard"
$Big_ALFA.Location = "170, 100"
$Big_ALFA.Size ="50,20"
$Big_ALFA.text ="2"
##コンボボックスに項目を追加
[void] $Big_ALFA.Items.Add("1")
[void] $Big_ALFA.Items.Add("2")
[void] $Big_ALFA.Items.Add("3")
[void] $Big_ALFA.Items.Add("4")
[void] $Big_ALFA.Items.Add("5")
[void] $Big_ALFA.Items.Add("6")
#入力欄:英数字
$En_NUM = New-Object combobox
$En_NUM.Name = "En_NUM"
$En_NUM.DropDownStyle = "DropDown"
$En_NUM.FlatStyle = "standard"
$En_NUM.Location = "170, 130"
$En_NUM.Size ="50,20"
$En_NUM.text ="2"
##コンボボックスに項目を追加
[void] $En_NUM.Items.Add("1")
[void] $En_NUM.Items.Add("2")
[void] $En_NUM.Items.Add("3")
[void] $En_NUM.Items.Add("4")
[void] $En_NUM.Items.Add("5")
[void] $En_NUM.Items.Add("6")
#入力欄:記号
$Symbol = New-Object combobox
$Symbol.Name = "Symbol"
$Symbol.DropDownStyle = "DropDown"
$Symbol.FlatStyle = "standard"
$Symbol.Location = "170, 160"
$Symbol.Size ="50,20"
$Symbol.text ="2"
##コンボボックスに項目を追加
[void] $Symbol.Items.Add("1")
[void] $Symbol.Items.Add("2")
[void] $Symbol.Items.Add("3")
[void] $Symbol.Items.Add("4")
[void] $Symbol.Items.Add("5")
[void] $Symbol.Items.Add("6")

#生成ボタン
$btn = New-Object Button
$btn.Text = "パスワードを生成する"
$btn.Size = "150, 30"
$btn.Location = "240, 215"
##生成ボタンのクリック
$button_Click = {
$MK_01 = $Small_ALFA.text
$MK_02 = $Big_ALFA.text
$MK_03 = $En_NUM.text
$MK_04 = $Symbol.text

function Get-RandomCharacters($length, $characters) {
    $random = 1..$length | ForEach-Object { Get-Random -Maximum $characters.length }
    $private:ofs=""
    return [String]$characters[$random]
}
 
$password = Get-RandomCharacters -length $MK_01 -characters 'abcdefghikmnoprstuvwxyz'
$password += Get-RandomCharacters -length $MK_02 -characters 'ABCDEFGHKLMNOPRSTUVWXYZ'
$password += Get-RandomCharacters -length $MK_03 -characters '234567890'
$password += Get-RandomCharacters -length $MK_04 -characters '!$%&/()=?}][{@#'
 
function Scramble-String([string]$inputString){     
    $characterArray = $inputString.ToCharArray()   
    $scrambledStringArray = $characterArray | Get-Random -Count $characterArray.Length     
    $outputString = -join $scrambledStringArray
    return $outputString 
}

$password = Scramble-String $password
$Label_08.text = $password

}
$btn.Add_Click($button_Click)

$CloseButton = New-Object System.Windows.Forms.Button
$CloseButton.Location = "470,215"
$CloseButton.size = "80,30"
$CloseButton.text  =　"閉じる"
$CloseButton.DialogResult = [System.Windows.Forms.DialogResult]::Cancel

# フォーム
$f = New-Object Form
$f.Text = "パスワード生成プログラム @word"
$f.Size = "590, 330"
$f.Controls.AddRange(@($Label_01,$Label_02,$Label_03,$Label_04,$Label_05,$Label_06,$Label_07,$Label_08,$Label_09,$Label_10,$Label_11,$Label_12,$Label_13,$Small_ALFA,$Big_ALFA,$En_NUM,$Symbol,$btn,$CloseButton))
$f.ShowDialog()